# -*- coding: utf-8 -*-

"""
/***************************************************************************
 WaterPurification
                                 A QGIS plugin
 Water Purification
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2025-04-23
        copyright            : (C) 2025 by ICRA
        email                : ollorente@icra.cat
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

__author__ = 'ICRA'
__date__ = '2025-04-23'
__copyright__ = '(C) 2025 by ICRA'

# This will get replaced with a git SHA1 when you do a git archive

__revision__ = '$Format:%H$'

import os
import sys
import inspect

from PyQt5.QtCore import *
from PyQt5.QtGui import *
from PyQt5.QtWidgets import *
from qgis.core import *
from qgis.core import QgsProcessingAlgorithm, QgsApplication
from .water_purification_provider import WaterPurificationProvider

from processing.gui.AlgorithmDialog import AlgorithmDialog
from qgis.core import QgsApplication, QgsProcessingFeedback, QgsProcessingParameters

from .allProcess.wpchannel import WaterPurificationChannel as WaterPurificationChannel
from .allProcess.wplandscape import WaterPurificationLandscape as WaterPurificationLandscape

cmd_folder = os.path.split(inspect.getfile(inspect.currentframe()))[0]

if cmd_folder not in sys.path:
    sys.path.insert(0, cmd_folder)


class WaterPurificationPlugin(object):

    def __init__(self, iface):
        self.provider = None
        self.iface = iface
        self.provider = WaterPurificationProvider()

    def initProcessing(self):
        """Init Processing provider for QGIS >= 3.8."""
        self.provider = WaterPurificationProvider()
        QgsApplication.processingRegistry().addProvider(self.provider)

    def WaterChannel(self):
        servei = WaterPurificationChannel()
        servei.initAlgorithm()
        servei.setProvider(self.provider)
        dlg = AlgorithmDialog(servei, parent=self.iface.mainWindow())
        dlg.show()
        # do NOT remove!!!! if you do then sip forgets the python subclass of AlgorithmDialog and you get a broken
        # dialog
        dlg.exec_()

    def WaterLandscape(self):
        servei = WaterPurificationLandscape()
        servei.initAlgorithm()
        servei.setProvider(self.provider)
        dlg = AlgorithmDialog(servei, parent=self.iface.mainWindow())
        dlg.show()
        # do NOT remove!!!! if you do then sip forgets the python subclass of AlgorithmDialog and you get a broken
        # dialog
        dlg.exec_()

    def initGui(self):
        self.menu = QMenu("S+WaterPurification", self.iface.mainWindow().menuBar())
        self.WaterChannel_action = QAction("Channel Purification", self.iface.mainWindow())
        self.WaterLandscape_action = QAction("Landscape Purification", self.iface.mainWindow())

        actions = self.iface.mainWindow().menuBar().actions()
        lastAction = actions[-1]
        self.iface.mainWindow().menuBar().insertMenu(lastAction, self.menu)
        self.menu.addAction(self.WaterChannel_action)
        self.menu.addAction(self.WaterLandscape_action)

        self.WaterChannel_action.triggered.connect(self.WaterChannel)
        self.WaterLandscape_action.triggered.connect(self.WaterLandscape)
        self.initProcessing()

    def unload(self):
        QgsApplication.processingRegistry().removeProvider(self.provider)
